# -*- coding: utf-8 -*-


Author:       Marco de Freitas

Copyright:    Copyright © 2021 Marco de Freitas

License:      GNU Lesser General Public License 3


Musenot dev 


Two level pattern
=================
Music theory concepts are represented by two levels of abstraction. An abstract general representation, calss name prefix "Abs". A concrete representation, that herits from the previous. 
* Music notes are represented by AbsNotes class and Notes class.
* Music intervals are represented by Absterval class and Interval class.
* Music scales are represented by Abscales and scales. 
* Music chords are represented by Abschords and Chords.

Modular arithmetic
==================

Modular arithmetic is extensively used because it's a very straigthforward way to implement cyclic structures that make the core of music theory: note names cycle, generic major scale structure.
Those Globals are stored in musenot.default module in the form of iterables over wich a cycle is implemented: NAMES_WHEEL, SCALE, DEGREES_semitones, Interval_types


Simple abstractions and their names classes
===========================================
Notes and intervals are simple object abstractions. Because simple abstraction names provide relevant information, their names a represented by a class: NoteName and Alteration for music notes, and, IntervalName for music intervals. 

* NoteName: label, index (in NAMES_WHEEL, replace ny name_index?), indexInRefScale (scale_index?)
* Alteration: label, value

* IntervalName: label, type, value

Containers
==========
scales, chords and tone rows are compound objects. There object representation is a "list alike" data structures that contain simple abstraction objects (notes, intervals). Compound objects attributs use the following naming convention: 


* degrees, intervals from root note
* steps, successiv intervals 
* code, steps representation in half_steps


