'''Musenot is a python package for manipulation of general concepts of western music theory used in jazz, pop-rock and
other contemporary music styles. Musenot sticks to pure abstract level and doesn't provide neither audio
# capabilities or graphical outputs like scores or tabs. '''

from musenot.default import *
from musenot.alteration import *
from musenot.notename import *
from musenot.notes import *
from musenot.intervals import *
from musenot.scales import *
from musenot.chords import *





    
